/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : PWM Headlamd 
Version : 1.2
Date    : 06.03.2011
Author  : Mitya                           
Company : NSS                             
Comments: 
 :  = 1  = 1  = 0
       6,25% 
  100%   :  6,25%
   EEPROM.
  ~ 1 .
:
5 PB0    0
6 PB1  1   , 0  .
7 PB2  1  
2 PB3  0  
3 PB4    
1 PB5  


Chip type           : ATtiny13
Clock frequency     : 4,800000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 16
*****************************************************/

#include <tiny13.h>
#include <delay.h>
    
#define starttime 30 //  
          
unsigned char GetData (void)
{
unsigned char i, j;
for(i=0;i<30;i++)  
  {                 
    delay_us(1000);
    j = (PINB & 0x1E);  // pb1 - pb4
    delay_us(1000);
    if(j != (PINB & 0x1E)) i=0;
  }
return j;
}
 
eeprom int pwm_level;
int pwm_current = 0; 
int pwm_step    = 1;
unsigned char laststate   = 0;
unsigned char oldgab      = 0;
unsigned char oldbrk      = 0;

void main(void)
{
unsigned char dt   = 0;

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State5=P State4=P State3=P State2=T State1=0 State0=0 
PORTB=0x38;
DDRB=0x03;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 18,750 kHz
// Mode: Fast PWM top=FFh
// OC0A output: Non-Inverted PWM
// OC0B output: Disconnected
TCCR0A=0x83;
TCCR0B=0x04;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/1024k
// Watchdog Timer interrupt: Off
#pragma optsize-
WDTCR=0x39;
WDTCR=0x29;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

pwm_step = pwm_level / starttime + 1; //  .
oldgab = ((dt & 0x04) != 0); //  
oldbrk = ((dt & 0x08) != 0); //

PORTB.1 = 0x00;

while (1)
   {
      #asm("wdr")  //  WDT

      dt = GetData(); //      

      delay_ms(100); 

      if ((dt & 0x10) == 0x00) { 
        //  
        if (laststate == 0x00) {
            laststate = 0x01;
            pwm_level += 16;
            if (pwm_level > 239) {
                pwm_level = 15; 
                pwm_current = 0;
            }
            pwm_step = pwm_level / starttime + 1; //  .
        }
      } else {
       laststate = 0x00;
       if ((dt & 0x0C) == 0x08) {
         // 
         if (pwm_current < pwm_level) {
              pwm_current += pwm_step;
              if (pwm_current > pwm_level) {
                 pwm_current = pwm_level;
              }
         }
       } else {
         // 
         if (pwm_current > 0) {
              pwm_current = 0;

//              pwm_current -= pwm_step;
              if (pwm_current < 0) {
                 pwm_current = 0;
              }
         }
       }
      }
      
      if (pwm_current == 0x00) {                
        OCR0A  = 0x00; 
        TCCR0A = 0x00;      
      } else {
        OCR0A  = pwm_current;
        TCCR0A = 0x83;
      }      
      
//      (dt &  0x04) = 1  
//      (dt &  0x08) = 0  

      if ((((dt & 0x04) != 0) && (oldgab == 0)) 
       || (((dt & 0x08) != 0) && (oldbrk == 0)) && ((dt & 0x04) != 0))
      {
        PORTB.1 = 0x01;
      } else 
      if ((((dt & 0x04) == 0) && (oldgab == 1)) 
       || (((dt & 0x08) == 0) && (oldbrk == 1)))
      {
        PORTB.1 = 0x00;
      }                     
      oldgab = ((dt & 0x04) != 0);
      oldbrk = ((dt & 0x08) != 0);

   }
}
